routes/web.php
<?php

use App\Http\Controllers\Admin\AdminController;
use App\Http\Controllers\Admin\FacultyController;
use App\Http\Controllers\Admin\TeacherController as AdminTeacherController;
use App\Http\Controllers\Admin\UserController as AdminUserController;
use App\Http\Controllers\Teacher\TeacherController;
use App\Http\Controllers\User\UserController;
use Illuminate\Support\Facades\Auth;
use Illuminate\Support\Facades\Route;

/*
|--------------------------------------------------------------------------
| Web Routes
|--------------------------------------------------------------------------
|
| Here is where you can register web routes for your application. These
| routes are loaded by the RouteServiceProvider within a group which
| contains the "web" middleware group. Now create something great!
|
 */

Route::get('/', function () {
    if (Auth::check()) {
        return redirect()->back()->with('status', 'you are already logged in');
    } else {
        return view('auth.login');
    }

});

//Middleware group
Route::middleware(['middleware' => 'PreventBackHistory'])->group(function () {
    Auth::routes();
});

// Route::get('/home', [App\Http\Controllers\HomeController::class, 'index'])->name('home');

//Admin
Route::group(['namespace' => 'Admin', 'prefix' => 'admin', 'as' => 'admin.', 'middleware' => ['isAdmin', 'auth', 'PreventBackHistory']], function () {
    Route::get('dashboard', [AdminController::class, 'index'])->name('dashboard');
    Route::get('profile', [AdminController::class, 'profile'])->name('profile');
    Route::get('settings', [AdminController::class, 'settings'])->name('settings');

    //Users CRUD -admin dashboard
    Route::get('/user/view', [AdminUserController::class, 'userView'])->name('userview');
    Route::get('/user/add', [AdminUserController::class, 'userAdd'])->name('useradd');
    Route::post('/user/store', [AdminUserController::class, 'userStore'])->name('userstore');
    Route::get('/user/edit/{id}', [AdminUserController::class, 'userEdit'])->name('useredit');
    Route::post('/user/update/{id}', [AdminUserController::class, 'userUpdate'])->name('userupdate');
    Route::get('/user/delete/{id}', [AdminUserController::class, 'userDelete'])->name('userdelete');

    //Teachers CRUD -admin-dashboard
    Route::get('/teacher/view', [AdminTeacherController::class, 'teacherView'])->name('teacherview');
    Route::get('/teacher/add', [AdminTeacherController::class, 'teacherAdd'])->name('teacheradd');
    Route::post('/teacher/store', [AdminTeacherController::class, 'teacherStore'])->name('teacherstore');
    Route::get('/teacher/edit/{id}', [AdminTeacherController::class, 'teacherEdit'])->name('teacheredit');
    Route::post('/teacher/update/{id}', [AdminTeacherController::class, 'teacherUpdate'])->name('teacherupdate');
    Route::get('/teacher/delete/{id}', [AdminTeacherController::class, 'teacherDelete'])->name('teacherdelete');

    //Faculty CRUD -admin-dashboard
    Route::get('/faculty/view', [FacultyController::class, 'facultyView'])->name('facultyview');
    Route::get('/faculty/add', [FacultyController::class, 'facultyAdd'])->name('facultyadd');
    Route::post('/faculty/store', [FacultyController::class, 'facultyStore'])->name('facultystore');
    Route::get('/faculty/edit/{id}', [FacultyController::class, 'facultyEdit'])->name('facultyedit');
    Route::post('/faculty/update/{id}', [FacultyController::class, 'facultyUpdate'])->name('facultyupdate');
    Route::get('/faculty/delete/{id}', [FacultyController::class, 'facultyDelete'])->name('facultydelete');
});

//Teacher
Route::group(['namespace' => 'Teacher', 'prefix' => 'teacher', 'as' => 'teacher.', 'middleware' => ['isTeacher', 'auth', 'PreventBackHistory']], function () {
    //profile
    Route::get('profile', [TeacherController::class, 'profile'])->name('profile');
    Route::get('/profile/edit', [TeacherController::class, 'profileEdit'])->name('editprofile');
    Route::post('/profile/store', [TeacherController::class, 'profileStore'])->name('profilestore');
    //settings
    Route::get('settings', [TeacherController::class, 'settings'])->name('settings');
    Route::post('settings/changepassword', [TeacherController::class, 'changePassword'])->name('profilesettings');
});

//User
Route::group(['namespace' => 'User', 'prefix' => 'user', 'as' => 'user.', 'middleware' => ['isUser', 'auth', 'PreventBackHistory']], function () {
    //profile
    Route::get('profile', [UserController::class, 'profile'])->name('profile');
    Route::get('/profile/edit', [UserController::class, 'profileEdit'])->name('editprofile');
    Route::post('/profile/store', [UserController::class, 'profileStore'])->name('profilestore');
    //settings
    Route::get('settings', [UserController::class, 'settings'])->name('settings');
    Route::post('settings/changepassword', [UserController::class, 'changePassword'])->name('profilesettings');

});

app/Models/Faculty.php
<?php

namespace App\Models;

use Illuminate\Database\Eloquent\Factories\HasFactory;
use Illuminate\Database\Eloquent\Model;

class Faculty extends Model
{
    use HasFactory;

    protected $fillable = [
        'name',
    ];

    public function users()
    {

        return $this->hasMany(User::class);

    }
}

app/Http/Controllers/Admin/FacultyController.php
<?php

namespace App\Http\Controllers\Admin;

use App\Http\Controllers\Controller;
use App\Models\Faculty;
use Illuminate\Http\Request;

class FacultyController extends Controller
{
    public function facultyView()
    {
        // $allData = User::all();
        $data['allData'] = Faculty::all(); // fetching data from multiple models
        return view('backend.faculty.view_faculty', $data);
    }

    public function facultyAdd()
    {
        return view('backend.faculty.add_faculty');
    }

    public function facultyStore(Request $request)
    {
        $request->validate([
            'name' => 'required',
        ]);
        $data = new Faculty();
        $data->name = $request->name;
        if ($data->save()) {
            return redirect()->route('admin.facultyview')->with('success', 'Faculty is Created');
        }
        return redirect()->back()->with('error', "could not create the faculty");
    }

    public function facultyEdit($id)
    {
        $editData = Faculty::find($id);
        return view('backend.faculty.edit_faculty', compact('editData'));
    }

    public function facultyUpdate(Request $request, $id)
    {
        $data = Faculty::find($id);
        $data->name = $request->name;

        if ($data->update()) {
            return redirect()->route('admin.facultyview')->with('success', 'Student info Updated');
        }
        return redirect()->back()->with('error', "could not update the user data");
    }

    public function facultyDelete($id)
    {
        $user = Faculty::find($id);
        $user->delete();
        return redirect()->route('admin.facultyview')->with('success', 'User Deleted Successfully');
    }
}

resources/views/backend/faculty/add_faculty.blade.php
@extends('dashboard.admins.admin_master')
@section('admin-content')
<div class="content-wrapper">
    <div class="container-full">


        <section class="content">

            <!-- Basic Forms -->
            <div class="box">
                <div class="box-header with-border">
                    <h4 class="box-title">Add Student</h4>

                </div>
                <!-- /.box-header -->
                <div class="box-body">
                    <div class="row">
                        <div class="col">
                            <form method="POST" action="{{ route('admin.facultystore') }}">
                                @csrf
                                <div class="row">
                                    <div class="col-12">
                                        <div class="form-group">
                                            <h5>Name<span class="text-danger">*</span></h5>
                                            <div class="controls">
                                                <input type="text" name="name" id="name" class="form-control"
                                                    data-validation-required-message="This field is required">
                                                <div class="help-block"></div>
                                            </div>
                                        </div>
                                        <div class="text-xs-right">
                                            <input type="submit" class="btn btn--rounded btn-info mb-5"
                                                value="Add faculty">
                                        </div>
                            </form>

                        </div>
                        <!-- /.col -->
                    </div>
                    <!-- /.row -->
                </div>
                <!-- /.box-body -->
            </div>
            <!-- /.box -->

        </section>


    </div>
</div>
@endsection

resources/views/backend/faculty/edit_faculty.blade.php
@extends('dashboard.admins.admin_master')
@section('admin-content')
<div class="content-wrapper">
    <div class="container-full">


        <section class="content">

            <!-- Basic Forms -->
            <div class="box">
                <div class="box-header with-border">
                    <h4 class="box-title">Update Faculty</h4>

                </div>
                <!-- /.box-header -->
                <div class="box-body">
                    <div class="row">
                        <div class="col">
                            <form method="POST" action="{{ route('admin.facultyupdate',$editData->id) }}">
                                @csrf
                                <div class="row">
                                    <div class="col-12">
                                        <div class="form-group">
                                            <h5>Name<span class="text-danger">*</span></h5>
                                            <div class="controls">
                                                <input type="text" name="name" id="name" class="form-control"
                                                    data-validation-required-message="This field is required"
                                                    value="{{ $editData->name }}">
                                                <div class="help-block"></div>
                                            </div>
                                        </div>
                                        <div class="text-xs-right">
                                            <input type="submit" class="btn btn--rounded btn-info mb-5" value="update">
                                        </div>
                            </form>

                        </div>
                        <!-- /.col -->
                    </div>
                    <!-- /.row -->
                </div>
                <!-- /.box-body -->
            </div>
            <!-- /.box -->

        </section>


    </div>
</div>
@endsection

resources/views/backend/faculty/view_faculty.blade.php
@extends('dashboard.admins.admin_master')
@section('admin-content')
<div class="content-wrapper">
    <div class="container-full">
        <!-- Main content -->
        <section class="content">
            <div class="row">

                <div class="col-12">

                    <div class="box">
                        <div class="box-header with-border">
                            <h3 class="box-title">Faculty Management</h3>
                            @if (session('success'))
                            <div class="alert alert-success" role="alert">
                                {{ session('success') }}
                            </div>
                            @endif
                            @if (session('error'))
                            <div class="alert alert-danger" role="alert">
                                {{ session('error') }}
                            </div>
                            @endif
                            <a href="{{ route('admin.facultyadd') }}" style="float: right"
                                class="btn btn-rounded btn-success mb-5">Add Faculty</a>
                        </div>
                        <!-- /.box-header -->
                        <div class="box-body">
                            <div class="table-responsive">
                                <table id="example1" class="table table-bordered table-striped">
                                    <thead>
                                        <tr>
                                            <th>SL</th>
                                            <th>Faculty</th>
                                        </tr>
                                    </thead>
                                    <tbody>
                                        @foreach ($allData as $key => $faculty )
                                        <tr>
                                            <td>{{ $key+1 }}</td>
                                            <td>{{$faculty->name }}</td>

                                            <td>
                                                <a href="{{ route('admin.facultyedit',$faculty->id) }}"
                                                    class="btn btn-info">Edit</a>
                                                <a href="{{ route('admin.facultydelete',$faculty->id) }}"
                                                    class="btn btn-danger">Delete</a>
                                            </td>
                                        </tr>
                                        @endforeach
                                    </tbody>
                                    <tfoot>
                                        <tr>
                                            <th>SL</th>
                                            <th>Name</th>
                                        </tr>
                                    </tfoot>
                                </table>
                            </div>
                        </div>
                        <!-- /.box-body -->
                    </div>
                    <!-- /.box -->
                </div>
                <!-- /.col -->
            </div>
            <!-- /.row -->
        </section>
        <!-- /.content -->

    </div>
</div>
@endsection